fish: update fisher, various changes

This commit is contained in:
Hoang Nguyen 2021-04-17 15:40:45 +03:00
parent f3a55ed79f
commit e0e16763c7
No known key found for this signature in database
GPG Key ID: 813CF484F4993419
10 changed files with 140 additions and 129 deletions

View File

@ -30,7 +30,6 @@ case ${shell} in
cp -rfv ./home/.bashrc ~/.bashrc cp -rfv ./home/.bashrc ~/.bashrc
cp -rfv ./home/.bash_profile ~/.bash_profile cp -rfv ./home/.bash_profile ~/.bash_profile
cp -rfv ./home/.config/fish/ ~/.config/fish/ cp -rfv ./home/.config/fish/ ~/.config/fish/
mkdir -pv ~/.config/fish/completions
;; ;;
*) *)
exit ;; exit ;;
@ -120,6 +119,7 @@ cp -rfv ./home/.config/tmux/ ~/.config/tmux/
cp -rfv ./home/.config/translate-shell/ ~/.config/translate-shell/ cp -rfv ./home/.config/translate-shell/ ~/.config/translate-shell/
# cp -rfv ./home/.config/tridactyl/ ~/.config/tridactyl/ # cp -rfv ./home/.config/tridactyl/ ~/.config/tridactyl/
cp -rfv ./home/.config/vifm/ ~/.config/vifm/ cp -rfv ./home/.config/vifm/ ~/.config/vifm/
cp -rfv ./home/.config/wget/ ~/.config/wget/
cp -rfv ./home/.config/youtube-dl/ ~/.config/youtube-dl/ cp -rfv ./home/.config/youtube-dl/ ~/.config/youtube-dl/
cp -rfv ./home/.config/ytmdl/ ~/.config/ytmdl/ cp -rfv ./home/.config/ytmdl/ ~/.config/ytmdl/
cp -rfv ./home/.config/zathura/ ~/.config/zathura/ cp -rfv ./home/.config/zathura/ ~/.config/zathura/

View File

@ -39,6 +39,7 @@ export IPYTHONDIR=$XDG_CONFIG_HOME/ipython
export XAUTHORITY=$XDG_RUNTIME_DIR/Xauthority export XAUTHORITY=$XDG_RUNTIME_DIR/Xauthority
export XINITRC=$XDG_CONFIG_HOME/X11/xinitrc export XINITRC=$XDG_CONFIG_HOME/X11/xinitrc
export XSERVERRC=$XDG_CONFIG_HOME/X11/xserverrc export XSERVERRC=$XDG_CONFIG_HOME/X11/xserverrc
export WGETRC=$XDG_CONFIG_HOME/wget/wgetrc
# env # env
export PAGER="less -R" export PAGER="less -R"
@ -374,7 +375,6 @@ export PATH=$HOME/.local/bin:$HOME/.local/bin/fzf:$HOME/.local/share/bash/basher
# /_/ |_/_/ /_/ \__,_/ /____/ # /_/ |_/_/ /_/ \__,_/ /____/
# #
# remap # remap
alias doas="doas --"
alias p="pulsemixer" alias p="pulsemixer"
alias ls="exa -lF --icons --sort=type" alias ls="exa -lF --icons --sort=type"
alias la="exa -laF --icons --sort=type" alias la="exa -laF --icons --sort=type"

View File

@ -29,7 +29,7 @@
# the top and down respectively. # the top and down respectively.
# The width can be negative. In this case the actual width is the # The width can be negative. In this case the actual width is the
# screen width minus the width defined in within the geometry option. # screen width minus the width defined in within the geometry option.
geometry = "300x5-5+30" geometry = "300x5-20+30"
# Turn on the progess bar # Turn on the progess bar
progress_bar = true progress_bar = true

View File

@ -0,0 +1,7 @@
complete --command fisher --exclusive --long help --description "Print help"
complete --command fisher --exclusive --long version --description "Print version"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments install --description "Install plugins"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments update --description "Update installed plugins"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments remove --description "Remove installed plugins"
complete --command fisher --exclusive --condition __fish_use_subcommand --arguments list --description "List installed plugins matching regex"
complete --command fisher --exclusive --condition "__fish_seen_subcommand_from update remove" --arguments "(fisher list)"

View File

@ -5,7 +5,6 @@
# /_/ |_/_/ /_/ \__,_/ /____/ # /_/ |_/_/ /_/ \__,_/ /____/
# #
# remap # remap
alias doas='doas --'
abbr p pulsemixer abbr p pulsemixer
alias startx='startx $HOME/.config/X11/xinitrc' alias startx='startx $HOME/.config/X11/xinitrc'
alias fehwpp="feh --no-fehbg --bg-fill --randomize ~/Pictures/Wallpapers/*" alias fehwpp="feh --no-fehbg --bg-fill --randomize ~/Pictures/Wallpapers/*"

View File

@ -45,6 +45,7 @@ set -gx JUPYTER_CONFIG_DIR $XDG_CONFIG_HOME/jupyter
set -gx XAUTHORITY $XDG_RUNTIME_DIR/Xauthority set -gx XAUTHORITY $XDG_RUNTIME_DIR/Xauthority
set -gx XINITRC $XDG_CONFIG_HOME/X11/xinitrc set -gx XINITRC $XDG_CONFIG_HOME/X11/xinitrc
set -gx XSERVERRC $XDG_CONFIG_HOME/X11/xserverrc set -gx XSERVERRC $XDG_CONFIG_HOME/X11/xserverrc
set -gx WGETRC $XDG_CONFIG_HOME/wget/wgetrc
# env # env
set -gx EDITOR nvim set -gx EDITOR nvim

View File

@ -1,206 +1,209 @@
set -g fisher_version 4.1.0 function fisher --argument-names cmd --description "A plugin manager for Fish"
set --query fisher_path || set --local fisher_path $__fish_config_dir
function fisher -a cmd -d "fish plugin manager" set --local fisher_version 4.3.0
set -q fisher_path || set -l fisher_path $__fish_config_dir set --local fish_plugins $__fish_config_dir/fish_plugins
set -l fish_plugins $__fish_config_dir/fish_plugins
switch "$cmd" switch "$cmd"
case -v --version case -v --version
echo "fisher, version $fisher_version" echo "fisher, version $fisher_version"
case "" -h --help case "" -h --help
echo "usage: fisher install <plugins...> install plugins" echo "Usage: fisher install <plugins...> Install plugins"
echo " fisher remove <plugins...> remove installed plugins" echo " fisher remove <plugins...> Remove installed plugins"
echo " fisher update <plugins...> update installed plugins" echo " fisher update <plugins...> Update installed plugins"
echo " fisher update update all installed plugins" echo " fisher update Update all installed plugins"
echo " fisher list [<regex>] list installed plugins matching regex" echo " fisher list [<regex>] List installed plugins matching regex"
echo "options:" echo "Options:"
echo " -v or --version print fisher version" echo " -v or --version Print version"
echo " -h or --help print this help message" echo " -h or --help Print this help message"
case ls list case ls list
string match --entire --regex -- "$argv[2]" $_fisher_plugins string match --entire --regex -- "$argv[2]" $_fisher_plugins
case install update remove case install update remove
isatty || read -laz stdin && set -a argv $stdin isatty || read --local --null --array stdin && set --append argv $stdin
set -l install_plugins
set -l update_plugins
set -l remove_plugins
set -l arg_plugins $argv[2..-1]
set -l old_plugins $_fisher_plugins
set -l new_plugins
if not set -q argv[2] set --local install_plugins
if test "$cmd" != update || test ! -e $fish_plugins set --local update_plugins
echo "fisher: not enough arguments for command: \"$cmd\"" >&2 && return 1 set --local remove_plugins
set --local arg_plugins $argv[2..-1]
set --local old_plugins $_fisher_plugins
set --local new_plugins
if ! set --query argv[2]
if test "$cmd" != update
echo "fisher: Not enough arguments for command: \"$cmd\"" >&2 && return 1
else if test ! -e $fish_plugins
echo "fisher: \"$fish_plugins\" file not found: \"$cmd\"" >&2 && return 1
end end
set arg_plugins (string trim <$fish_plugins) set arg_plugins (string match --regex -- '^[^\s]+$' <$fish_plugins)
end end
for plugin in $arg_plugins for plugin in $arg_plugins
test -e "$plugin" && set plugin (realpath $plugin) test -e "$plugin" && set plugin (realpath $plugin)
contains -- "$plugin" $new_plugins || set -a new_plugins $plugin contains -- "$plugin" $new_plugins || set --append new_plugins $plugin
end end
if set -q argv[2] if set --query argv[2]
for plugin in $new_plugins for plugin in $new_plugins
if contains -- "$plugin" $old_plugins if contains -- "$plugin" $old_plugins
if test "$cmd" = remove test "$cmd" = remove &&
set -a remove_plugins $plugin set --append remove_plugins $plugin ||
else set --append update_plugins $plugin
set -a update_plugins $plugin else if test "$cmd" = install
end set --append install_plugins $plugin
else if test "$cmd" != install
echo "fisher: plugin not installed: \"$plugin\"" >&2 && return 1
else else
set -a install_plugins $plugin echo "fisher: Plugin not installed: \"$plugin\"" >&2 && return 1
end end
end end
else else
for plugin in $new_plugins for plugin in $new_plugins
if contains -- "$plugin" $old_plugins contains -- "$plugin" $old_plugins &&
set -a update_plugins $plugin set --append update_plugins $plugin ||
else set --append install_plugins $plugin
set -a install_plugins $plugin
end
end end
for plugin in $old_plugins for plugin in $old_plugins
if not contains -- "$plugin" $new_plugins contains -- "$plugin" $new_plugins || set --append remove_plugins $plugin
set -a remove_plugins $plugin
end
end end
end end
set -l pid_list set --local pid_list
set -l source_plugins set --local source_plugins
set -l fetch_plugins $update_plugins $install_plugins set --local fetch_plugins $update_plugins $install_plugins
echo -e "\x1b[1mfisher $cmd version $fisher_version\x1b[22m" echo (set_color --bold)fisher $cmd version $fisher_version(set_color normal)
for plugin in $fetch_plugins for plugin in $fetch_plugins
set -l source (command mktemp -d) set --local source (command mktemp -d)
set -a source_plugins $source set --append source_plugins $source
command mkdir -p $source/{completions,conf.d,functions} command mkdir -p $source/{completions,conf.d,functions}
fish -c " fish --command "
if test -e $plugin if test -e $plugin
command cp -Rf $plugin/* $source command cp -Rf $plugin/* $source
else
set temp (command mktemp -d)
set name (string split \@ $plugin) || set name[2] HEAD
set url https://codeload.github.com/\$name[1]/tar.gz/\$name[2]
set -q fisher_user_api_token && set opts -u $fisher_user_api_token
echo -e \"fetching \x1b[4m\$url\x1b[24m\"
if command curl $opts -Ss -w \"\" \$url 2>&1 | command tar -xzf- -C \$temp 2>/dev/null
command cp -Rf \$temp/*/* $source
else else
echo fisher: invalid plugin name or host unavailable: \\\"$plugin\\\" >&2 set temp (command mktemp -d)
command rm -rf $source set name (string split \@ $plugin) || set name[2] HEAD
set url https://codeload.github.com/\$name[1]/tar.gz/\$name[2]
echo Fetching (set_color --underline)\$url(set_color normal)
if curl --silent \$url | tar -xzC \$temp -f - 2>/dev/null
command cp -Rf \$temp/*/* $source
else
echo fisher: Invalid plugin name or host unavailable: \\\"$plugin\\\" >&2
command rm -rf $source
end
command rm -rf \$temp
end end
command rm -rf \$temp
end
test ! -e $source && exit set files $source/* && string match --quiet --regex -- .+\.fish\\\$ \$files
command mv -f (string match --entire --regex -- \.fish\\\$ $source/*) $source/functions 2>/dev/null" & " &
set -a pid_list (jobs --last --pid) set --append pid_list (jobs --last --pid)
end end
wait $pid_list 2>/dev/null wait $pid_list 2>/dev/null
for plugin in $fetch_plugins for plugin in $fetch_plugins
if set -l source $source_plugins[(contains --index -- "$plugin" $fetch_plugins)] && test ! -e $source if set --local source $source_plugins[(contains --index -- "$plugin" $fetch_plugins)] && test ! -e $source
if set -l index (contains --index -- "$plugin" $install_plugins) if set --local index (contains --index -- "$plugin" $install_plugins)
set -e install_plugins[$index] set --erase install_plugins[$index]
else else
set -e update_plugins[(contains --index -- "$plugin" $update_plugins)] set --erase update_plugins[(contains --index -- "$plugin" $update_plugins)]
end end
end end
end end
for plugin in $update_plugins $remove_plugins for plugin in $update_plugins $remove_plugins
if set -l index (contains --index -- "$plugin" $_fisher_plugins) if set --local index (contains --index -- "$plugin" $_fisher_plugins)
set -l plugin_files_var _fisher_(string escape --style=var $plugin)_files set --local plugin_files_var _fisher_(string escape --style=var -- $plugin)_files
if contains -- "$plugin" $remove_plugins && set --erase _fisher_plugins[$index] if contains -- "$plugin" $remove_plugins
for file in (string match --entire --regex -- "conf\.d/" $$plugin_files_var) for name in (string replace --filter --regex -- '.+/conf\.d/([^/]+)\.fish$' '$1' $$plugin_files_var)
emit (string replace --all --regex -- '^.*/|\.fish$' "" $file)_uninstall emit {$name}_uninstall
end end
echo -es "removing \x1b[1m$plugin\x1b[22m" \n" "$$plugin_files_var printf "%s\n" Removing\ (set_color red --bold)$plugin(set_color normal) " "$$plugin_files_var
end end
command rm -rf $$plugin_files_var command rm -rf $$plugin_files_var
functions --erase (string match --entire --regex -- "functions/" $$plugin_files_var \ functions --erase (string replace --filter --regex -- '.+/functions/([^/]+)\.fish$' '$1' $$plugin_files_var)
| string replace --all --regex -- '^.*/|\.fish$' "")
for name in (string replace --filter --regex -- '.+/completions/([^/]+)\.fish$' '$1' $$plugin_files_var)
complete --erase --command $name
end
set --erase _fisher_plugins[$index]
set --erase $plugin_files_var set --erase $plugin_files_var
end end
end end
if set -q update_plugins[1] || set -q install_plugins[1] if set --query update_plugins[1] || set --query install_plugins[1]
command mkdir -p $fisher_path/{functions,conf.d,completions} command mkdir -p $fisher_path/{functions,conf.d,completions}
end end
for plugin in $update_plugins $install_plugins for plugin in $update_plugins $install_plugins
set -l source $source_plugins[(contains --index -- "$plugin" $fetch_plugins)] set --local source $source_plugins[(contains --index -- "$plugin" $fetch_plugins)]
set -l files $source/{functions,conf.d,completions}/* set --local files $source/{functions,conf.d,completions}/*
set -l plugin_files_var _fisher_(string escape --style=var $plugin)_files
set -q files[1] && set -U $plugin_files_var (string replace $source $fisher_path $files)
for file in (string replace -- $source "" $files) if set --local index (contains --index -- $plugin $install_plugins)
set --local user_files $fisher_path/{functions,conf.d,completions}/*
set --local conflict_files
for file in (string replace -- $source/ $fisher_path/ $files)
contains -- $file $user_files && set --append conflict_files $file
end
if set --query conflict_files[1] && set --erase install_plugins[$index]
echo -s "fisher: Cannot install \"$plugin\": please remove or move conflicting files first:" \n" "$conflict_files >&2
continue
end
end
for file in (string replace -- $source/ "" $files)
command cp -Rf $source/$file $fisher_path/$file command cp -Rf $source/$file $fisher_path/$file
end end
contains -- $plugin $_fisher_plugins || set -Ua _fisher_plugins $plugin set --local plugin_files_var _fisher_(string escape --style=var -- $plugin)_files
contains -- $plugin $install_plugins && set -l event "install" || set -l event "update" set --query files[1] && set --universal $plugin_files_var (string replace -- $source $fisher_path $files)
echo -es "installing \x1b[1m$plugin\x1b[22m" \n" "$$plugin_files_var
for file in (string match --entire --regex -- "[functions/|conf\.d/].*fish\$" $$plugin_files_var) contains -- $plugin $_fisher_plugins || set --universal --append _fisher_plugins $plugin
contains -- $plugin $install_plugins && set --local event install || set --local event update
printf "%s\n" Installing\ (set_color --bold)$plugin(set_color normal) " "$$plugin_files_var
for file in (string match --regex -- '.+/[^/]+\.fish$' $$plugin_files_var)
source $file source $file
if string match --quiet --regex -- "conf\.d/" $file if set --local name (string replace --regex -- '.+conf\.d/([^/]+)\.fish$' '$1' $file)
emit (string replace --all --regex -- '^.*/|\.fish$' "" $file)_$event emit {$name}_$event
end end
end end
end end
command rm -rf $source_plugins command rm -rf $source_plugins
functions -q fish_prompt || source $__fish_data_dir/functions/fish_prompt.fish
set -q _fisher_plugins[1] || set -e _fisher_plugins set --query _fisher_plugins[1] || set --erase _fisher_plugins
set -q _fisher_plugins && printf "%s\n" $_fisher_plugins >$fish_plugins || command rm -f $fish_plugins set --query _fisher_plugins &&
printf "%s\n" $_fisher_plugins >$fish_plugins ||
command rm -f $fish_plugins
set -l total (count $install_plugins) (count $update_plugins) (count $remove_plugins) set --local total (count $install_plugins) (count $update_plugins) (count $remove_plugins)
test "$total" != "0 0 0" && echo (string join ", " ( test "$total" != "0 0 0" && echo (string join ", " (
test $total[1] = 0 || echo "installed $total[1]") ( test $total[1] = 0 || echo "Installed $total[1]") (
test $total[2] = 0 || echo "updated $total[2]") ( test $total[2] = 0 || echo "Updated $total[2]") (
test $total[3] = 0 || echo "removed $total[3]") test $total[3] = 0 || echo "Removed $total[3]")
) "plugin/s" ) plugin/s
case \* case \*
echo "fisher: unknown flag or command: \"$cmd\" (see `fisher -h`)" >&2 && return 1 echo "fisher: Unknown command: \"$cmd\"" >&2 && return 1
end end
end end
## Migrations ## ## Migrations ##
if functions -q _fisher_self_update || test -e $__fish_config_dir/fishfile # 3.x function _fisher_fish_postexec --on-event fish_postexec
function _fisher_migrate if functions --query _fisher_list
function _fisher_complete fisher update >/dev/null 2>/dev/null
fisher install jorgebucaran/fisher >/dev/null 2>/dev/null set --query XDG_DATA_HOME || set --local XDG_DATA_HOME ~/.local/share
functions --erase _fisher_complete test -e $XDG_DATA_HOME/fisher && command rm -rf $XDG_DATA_HOME/fisher
end functions --erase _fisher_list _fisher_plugin_parse
set -q XDG_DATA_HOME || set XDG_DATA_HOME ~/.local/share set --erase fisher_data
set -q XDG_CACHE_HOME || set XDG_CACHE_HOME ~/.cache
set -q XDG_CONFIG_HOME || set XDG_CONFIG_HOME ~/.config
set -q fisher_path || set fisher_path $__fish_config_dir
test -e $__fish_config_dir/fishfile && command awk '/#|^gitlab|^ *$/ { next } $0' <$__fish_config_dir/fishfile >>$__fish_config_dir/fish_plugins
command rm -rf $__fish_config_dir/fishfile $fisher_path/{conf.d,completions}/fisher.fish {$XDG_DATA_HOME,$XDG_CACHE_HOME,$XDG_CONFIG_HOME}/fisher
functions --erase _fisher_migrate _fisher_copy_user_key_bindings _fisher_ls _fisher_fmt _fisher_self_update _fisher_self_uninstall _fisher_commit _fisher_parse _fisher_fetch _fisher_add _fisher_rm _fisher_jobs _fisher_now _fisher_help
fisher update
end end
echo "upgrading to fisher $fisher_version -- learn more at" (set_color --bold --underline)"https://git.io/fisher-4"(set_color normal) functions --erase _fisher_fish_postexec
_fisher_migrate >/dev/null 2>/dev/null end
else if functions -q _fisher_list # 4.0
set -q XDG_DATA_HOME || set -l XDG_DATA_HOME ~/.local/share
test -e $XDG_DATA_HOME/fisher && command rm -rf $XDG_DATA_HOME/fisher
functions --erase _fisher_list _fisher_plugin_parse
echo -n "upgrading to fisher $fisher_version new in-memory state.."
fisher update >/dev/null 2>/dev/null
echo -ne "done\r\n"
end

1
home/.config/wget/wgetrc Normal file
View File

@ -0,0 +1 @@
hsts-file=~/.cache/wget-hsts

View File

@ -35,6 +35,7 @@ export JUPYTER_CONFIG_DIR=$XDG_CONFIG_HOME/jupyter
export XAUTHORITY=$XDG_RUNTIME_DIR/Xauthority export XAUTHORITY=$XDG_RUNTIME_DIR/Xauthority
export XINITRC=$XDG_CONFIG_HOME/X11/xinitrc export XINITRC=$XDG_CONFIG_HOME/X11/xinitrc
export XSERVERRC=$XDG_CONFIG_HOME/X11/xserverrc export XSERVERRC=$XDG_CONFIG_HOME/X11/xserverrc
export WGETRC=$XDG_CONFIG_HOME/wget/wgetrc
# env # env
export PAGER="less -R" export PAGER="less -R"

View File

@ -1,5 +1,4 @@
# remap # remap
alias doas="doas --"
alias p="pulsemixer" alias p="pulsemixer"
alias startx="startx $HOME/.config/X11/xinitrc" alias startx="startx $HOME/.config/X11/xinitrc"
alias fehwpp="feh --no-fehbg --bg-fill --randomize ~/Pictures/Wallpapers/*" alias fehwpp="feh --no-fehbg --bg-fill --randomize ~/Pictures/Wallpapers/*"